local function SafeFreeSlot(...)
	for _,slot in ipairs({...})
		if not rawget(_G, slot) freeslot(slot) end -- Ensure we don't accidentally overlap existing freeslots
	end
end
local function SpawnCoins(mo, count)
	if count >= 500
		local coin = P_SpawnMobjFromMobj(mo,0,0,0,MT_WARIOLAND500COIN)
		mo.spawning = $ - 500
	elseif count >= 100
		local coin = P_SpawnMobjFromMobj(mo,0,0,0,MT_WARIOLAND100COIN)
		mo.spawning = $ - 100
	elseif count >= 50
		local coin = P_SpawnMobjFromMobj(mo,0,0,0,MT_WARIOLAND50COIN)
		mo.spawning = $ - 50
	elseif count >= 10
		local coin = P_SpawnMobjFromMobj(mo,0,0,0,MT_WARIOLAND10COIN)
		mo.spawning = $ - 10
	end
	if coin
		coin.angle = mo.angle-ANGLE_180
	end
end
if not srb2p
	rawset(_G, "coinlist", {
	[MT_BLUECRAWLA] = 20,
	[MT_REDCRAWLA] = 50,
	[MT_GFZFISH] = 20,
	[MT_GOLDBUZZ] = 40,
	[MT_REDBUZZ] = 80,
	[MT_JETTBOMBER] = 100,
	[MT_JETTGUNNER] = 100,
	[MT_CRAWLACOMMANDER] = 300,
	[MT_DETON] = 20,
	[MT_SKIM] = 40,
	[MT_POPUPTURRET] = 40,
	[MT_SPINCUSHION] = 50,
	[MT_CRUSHSTACEAN] = 50,
	[MT_BANPYURA] = 50,
	[MT_JETJAW] = 20,
	[MT_SNAILER] = 50,
	[MT_VULTURE] = 50,
	[MT_SPRINGSHELL] = 30,
	[MT_YELLOWSHELL] = 30,
	[MT_ROBOHOOD] = 50,
	[MT_FACESTABBER] = 300,
	[MT_UNIDUS] = 50,
	[MT_POINTY] = 40,
	[MT_CANARIVORE] = 30,
	[MT_PYREFLY] = 20,
	[MT_DRAGONBOMBER] = 50,
	[MT_EGGMOBILE] = 1000,
	[MT_EGGMOBILE2] = 1000,
	[MT_EGGMOBILE3] = 1000,
	[MT_EGGMOBILE4] = 1000,
	[MT_FANG] = 1000,
	[MT_CYBRAKDEMON] = 1000,
	[MT_METALSONIC_BATTLE] = 1000,
	[MT_GOOMBA] = 20,
	[MT_BLUEGOOMBA] = 20
	})
SafeFreeSlot("sfx_wl4dmg","sfx_whurt0","sfx_whurt1","sfx_whurt2","sfx_whurt3","sfx_whurt4","sfx_whurt5","sfx_whurt6","sfx_whurt7","sfx_wltran",
"MT_WLHEALTHDISP","S_WARIDISP","sfx_wmhart","sfx_saring","sfx_saflik","SPR_WLHP","sfx_wllowh",
"S_WARIOLAND50COIN","MT_WARIOLAND50COIN","sfx_wlcoi1",
"S_WARIOLAND10COIN","MT_WARIOLAND10COIN","SPR_WLC1","sfx_wlcoi2",
"S_WARIOLAND100COIN","MT_WARIOLAND100COIN","SPR_WLC3","sfx_wlcoi3",
"S_KEYZERASLEEP","S_KEYZERAWAKE","MT_KEYZER","SPR_WLKI","sfx_keyzer","MT_KEYZERFOLLOW","S_KOMBIHIDE",
"S_WARIOLAND500COIN","MT_WARIOLAND500COIN","SPR_WLC4","sfx_wlcoi4")
end
// add another here to make it easier to debug X-Tra
/* freeslot("sfx_w1up",
"sfx_waow0","sfx_waow1","sfx_waow2","sfx_waow3","sfx_waow4","sfx_waow5","sfx_waow6","sfx_waow7","sfx_waow8","sfx_waow9","sfx_waow10","sfx_waow11",
"sfx_waow12","sfx_waow13","sfx_waow14","sfx_waow15","sfx_waow16","sfx_waow17") */

mobjinfo[MT_WARIOLAND500COIN] = {
spawnstate = S_WARIOLAND500COIN,
spawnhealth = 1000,
deathstate = S_WARIOLAND500COIN,
radius = mobjinfo[MT_RING].radius/2,
height = mobjinfo[MT_RING].height/2,
dispoffset = 4,
flags = MF_SCENERY|MF_SPECIAL,
}

states[S_WARIOLAND500COIN] = {
	sprite = SPR_WLC4,
	frame = FF_ANIMATE|A,
	tics = -1,
	var1 = 6,
	var2 = 2,
	nextstate = S_WARIOLAND500COIN,
}

mobjinfo[MT_WARIOLAND100COIN] = {
spawnstate = S_WARIOLAND100COIN,
spawnhealth = 1000,
deathstate = S_WARIOLAND100COIN,
radius = mobjinfo[MT_RING].radius/2,
height = mobjinfo[MT_RING].height/2,
dispoffset = 4,
flags = MF_SCENERY|MF_SPECIAL,
}

states[S_WARIOLAND100COIN] = {
	sprite = SPR_WLC3,
	frame = FF_ANIMATE|A,
	tics = -1,
	var1 = 5,
	var2 = 2,
	nextstate = S_WARIOLAND100COIN,
}

mobjinfo[MT_WARIOLAND50COIN] = {
spawnstate = S_WARIOLAND50COIN,
spawnhealth = 1000,
deathstate = S_WARIOLAND50COIN,
radius = mobjinfo[MT_RING].radius/2,
height = mobjinfo[MT_RING].height/2,
dispoffset = 4,
flags = MF_SCENERY|MF_SPECIAL,
}

states[S_WARIOLAND50COIN] = {
	sprite = SPR_WLC2,
	frame = FF_ANIMATE|A,
	tics = -1,
	var1 = 5,
	var2 = 2,
	nextstate = S_WARIOLAND50COIN,
}

mobjinfo[MT_WARIOLAND10COIN] = {
spawnstate = S_WARIOLAND10COIN,
spawnhealth = 1000,
deathstate = S_WARIOLAND10COIN,
radius = mobjinfo[MT_RING].radius/2,
height = mobjinfo[MT_RING].height/2,
dispoffset = 4,
flags = MF_SCENERY|MF_SPECIAL,
}

states[S_WARIOLAND10COIN] = {
	sprite = SPR_WLC1,
	frame = FF_ANIMATE|A,
	tics = -1,
	var1 = 3,
	var2 = 2,
	nextstate = S_WARIOLAND10COIN,
}

mobjinfo[MT_KEYZER] = {
spawnstate = S_KEYZERASLEEP,
spawnhealth = 1000,
deathstate = S_KEYZERASLEEP,
radius = mobjinfo[MT_TOKEN].radius/2,
height = mobjinfo[MT_TOKEN].height/2,
dispoffset = 0,
flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SPECIAL,
}

states[S_KEYZERASLEEP] = {
	sprite = SPR_WLKI,
	frame = FF_ANIMATE|A,
	tics = -1,
	var1 = 7,
	var2 = 6,
	nextstate = S_KEYZERASLEEP,
}

states[S_KEYZERAWAKE] = {
	sprite = SPR_WLKI,
	frame = FF_ANIMATE|I,
	tics = -1,
	var1 = 3,
	var2 = 6,
	nextstate = S_KEYZERAWAKE,
}

mobjinfo[MT_KEYZERFOLLOW] = {
spawnstate = S_KOMBIHIDE,
spawnhealth = 1000,
deathstate = S_KOMBIHIDE,
radius = mobjinfo[MT_TOKEN].radius/2,
height = mobjinfo[MT_TOKEN].height/2,
dispoffset = 0,
flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING,
}

states[S_KOMBIHIDE] = {
	sprite = SPR_NULL,
	frame = A,
	tics = -1,
	var1 = 0,
	var2 = 0,
	nextstate = S_KOMBIHIDE,
}

mobjinfo[MT_WLHEALTHDISP] = {
spawnstate = S_WARIDISP,
spawnhealth = 4,
deathstate = S_WARIDISP,
radius = mobjinfo[MT_PLAYER].radius/2,
height = mobjinfo[MT_PLAYER].radius/2,
dispoffset = 72,
flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING,
}

states[S_WARIDISP] = {
	sprite = SPR_WLHP,
	tics = -1,
	var1 = 0,
	var2 = 0,
	nextstate = S_WARIDISP,
}

-- mobjinfo[MT_TOKEN].spawnstate = S_KOMBIHIDE
-- mobjinfo[MT_TOKEN].seestate = S_KOMBIHIDE

rawset(_G, "cv_wl4hp", CV_RegisterVar({
	name = "k_wl4health",
	defaultvalue = "On",
	flags = CV_SAVE|CV_SHOWMODIF,
	PossibleValue = {On = 1, Off = 0},
}))

rawset(_G, "cv_wl4coins", CV_RegisterVar({
	name = "k_wl4scoring",
	defaultvalue = "On",
	flags = CV_SAVE|CV_SHOWMODIF|CV_NETVAR,
	PossibleValue = {On = 1, Off = 0},
}))

rawset(_G, "cv_wl4hurtdrop", CV_RegisterVar({
	name = "k_wl4hurtdrop",
	defaultvalue = 400,
	flags = CV_SAVE|CV_SHOWMODIF|CV_NETVAR,
	PossibleValue = CV_UNSIGNED,
}))

rawset(_G, "cv_kombiwl4max", CV_RegisterVar({
	name = "k_wl4maxhealth",
	defaultvalue = 8,
	flags = CV_SAVE|CV_SHOWMODIF|CV_NETVAR,
	PossibleValue = {MIN = 1, MAX = 64},
}))

rawset(_G, "cv_kombiwl4spawnhp", CV_RegisterVar({
	name = "k_wl4spawnhealth",
	defaultvalue = 0,
	flags = CV_SAVE|CV_SHOWMODIF|CV_NETVAR,
	PossibleValue = {MIN = 0, MAX = 64},
}))

rawset(_G, "cv_kombiwl4trans", CV_RegisterVar({
	name = "k_wl4transformations",
	defaultvalue = 0,
	flags = CV_SAVE|CV_SHOWMODIF|CV_NETVAR,
	PossibleValue = {On = 1, Off = 0},
}))


/// Passive Ability: Health System
// you have a health gauge instead of a ring gauge

if not srb2p
sfxinfo[sfx_wl4dmg].caption = 'Damage'
sfxinfo[sfx_whurt0].caption = '"No, no..."'
sfxinfo[sfx_whurt1].caption = '"No no..."'
sfxinfo[sfx_whurt2].caption = '"Oh boy..."'
sfxinfo[sfx_whurt3].caption = '"Oh boy..."'
sfxinfo[sfx_whurt4].caption = '"Grr... no, no..."'
sfxinfo[sfx_whurt5].caption = '"Hee hee hee hee hee hee!"'
sfxinfo[sfx_whurt6].caption = '"Yeah!"'
sfxinfo[sfx_whurt7].caption = '"Hey!"'
sfxinfo[sfx_wmhart].caption = 'Mini-Heart'
sfxinfo[sfx_saring].caption = 'Sparkle'
sfxinfo[sfx_saflik].caption = 'Animal Escaping'
sfxinfo[sfx_saexpl].caption = 'Pop'
sfxinfo[sfx_wlcoi1].caption = 'Small Coin'
sfxinfo[sfx_wlcoi2].caption = 'Bronze Coin'
sfxinfo[sfx_wlcoi3].caption = 'Silver Coin'
sfxinfo[sfx_wllowh].caption = 'Low Health!'
sfxinfo[sfx_keyzer].caption = 'Keyzer Found'
end

// CUSTOMIZE SECTION START
local skin = "kombi" // your character here
local shieldtake = true // if this is true, shield will be taken in exchange for health if you have one
local hitsound = sfx_wl4dmg // the sound that will play once your hit
// CUSTOMIZE SECTION END, PROCEED BELOW IF YOU KNOW WHAT YOU'RE DOING
local healthbar = 1
addHook("PlayerSpawn", function(player)
	player.hp = nil
	player.hpdivvies = nil
	player.kombimode = 0
	player.keyzerfollow = P_SpawnMobjFromMobj(player.realmo,0,0,0,MT_KEYZERFOLLOW)
	player.keyzerfollow.target = player.realmo
end)

addHook("PlayerThink", function(player)
	if player.hp == nil
		if ultimatemode
			player.hpdivvies = 0
			player.hp = 1
		else
			if (mapheaderinfo[gamemap].bonustype == 1)
				player.hp = cv_kombiwl4max.value
				player.hpdivvies = -32768
			else
				player.hpdivvies = 0
				player.hp = (cv_kombiwl4spawnhp.value or cv_kombiwl4max.value/2) or 1
			end
		end
	end
	if not player.keyzerfollow
		player.keyzerfollow = P_SpawnMobjFromMobj(player.realmo,0,0,0,MT_KEYZERFOLLOW)
		player.keyzerfollow.target = player.realmo
	end
	if player.realmo and player.realmo.skin == skin
	and player.hp > cv_kombiwl4max.value
		player.hp = cv_kombiwl4max.value
	end
	if player.realmo and player.realmo.skin == skin
	and player.hpdivvies > 7
	and player.hp < cv_kombiwl4max.value
		player.hp = $ + 1
		player.hpdivvies = 0
	end
	if player.hpdivvies > 8
		player.hpdivvies = 8
	end
	if (maptol & TOL_NIGHTS)
		player.hp = 8
	end
	if player.scoreadd > 0 and player.realmo.skin == "kombi" and cv_wl4coins.string == "On"
		P_AddPlayerScore(player, -100)
		player.scoreadd = 0
	end
end)

local actualhealth
hud.add(function(v,player)
		if player.realmo and player.realmo.skin == skin
		local xpos = 254
		local ypos = hudinfo[HUD_SCORE].y + 12
			if not srb2p
			local tickbar = v.cachePatch("TICKBAR\$player.hpdivvies\")
			if not (maptol & TOL_NIGHTS)
				if CV_FindVar("k_wl4health").string == "On" 
					actualhealth = player.hp+((player.powers[pw_shield] & SH_FIREFLOWER)>>9)+((player.powers[pw_shield] & SH_FORCE)>>8 + (min((player.powers[pw_shield] & SH_FORCEHP),(player.powers[pw_shield] & SH_FORCE))) or ((player.powers[pw_shield] & SH_WHIRLWIND)>>1 or (player.powers[pw_shield] & SH_PITY))) -- there's DEFINITELY a better way to do this
					local offset = ((8-min(max(actualhealth,cv_kombiwl4max.value),8))*4)
					xpos = $ + offset
					for i = 1,max(actualhealth,cv_kombiwl4max.value) do
						if player.hp >= i
							if actualhealth == 1 and ((leveltime + player.leveltimeadd) % 53 <= 24)
								healthbar = v.cachePatch("WARIOHPW")
							else
								healthbar = v.cachePatch("WARIOHPF")
							end
						else
							if actualhealth >= i
								if leveltime%2 == 0
									healthbar = v.cachePatch("WARIOHPF")
								else
									healthbar = v.cachePatch("WARIOHPE")
								end
							else
								healthbar = v.cachePatch("WARIOHPE")
							end
						end
						v.draw(xpos+(8*(((i-1)%8))), ypos-(((i-1)/8)*-8), healthbar, V_HUDTRANS|V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER)
					end
					if not (mapheaderinfo[gamemap].levelflags & LF_WARNINGTITLE)
						xpos = $ - offset
						ypos = $ + 7 + ((((max(actualhealth,cv_kombiwl4max.value)-1)/8))*8)
						v.draw(xpos, ypos, tickbar, V_HUDTRANS|V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER)
					end
				end
			end
			end
			local playnum = player.kombimode or 0
			local playtype = v.cachePatch("ABILSET\$playnum\")
			if ((player.pflags & PF_THOKKED) or not (not P_IsObjectOnGround(player.realmo) and (player.pflags & PF_JUMPED)))
				v.draw(xpos+32, ypos+8, playtype, V_HUDTRANS|V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER, v.getColormap(player.realmo.skin, player.realmo.color))
				v.draw(xpos+32, ypos+8, playtype, V_40TRANS|V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER, v.getColormap(player.realmo.skin, SKINCOLOR_BONE))
			else
				v.draw(xpos+32, ypos+8, playtype, V_HUDTRANS|V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER, v.getColormap(player.realmo.skin, player.realmo.color))
			end
		end
end)

addHook("PlayerThink", function(player)
	if not player.realmo.transformation
		player.realmo.transformation = 0
	end
	if not player.leveltimeadd
		player.leveltimeadd = 0
	end
	if CV_FindVar("k_wl4health").string == "On"
		if (leveltime + player.leveltimeadd) % 53 == 0 and actualhealth == 1
			S_StartSound(target, sfx_wllowh) -- I had to rip this myself. I really wish I didn't have to.
		end
	end
end)

addHook("MobjDamage", function(target, inf, src, dmg, dmgType)
	if (dmgType & DMG_SPIKE) and target.player.spinjumping and abs(target.momz) >= 3*FRACUNIT
		S_StartSound(target, sfx_kmwkik)
		P_SetObjectMomZ(target, -3*target.momz/4, false)
		return true
	end
	if target.skin == skin and not(target.player.powers[pw_super] or target.player.powers[pw_flashing])
	/* if (dmgType & DMG_FIRE) and cv_kombiwl4trans.value == 1 and inf and not inf.wl4notransform
		if target.transformation == 0
			S_StartSound(target, P_RandomRange(sfx_whurt0,sfx_whurt7))
			S_StartSound(target, sfx_wltran)
			target.transformation = 1
		end
		return true
	end
	if (dmgType & DMG_CRUSHED) and cv_kombiwl4trans.value == 1 and not mapheaderinfo[gamemap].kombi_wl4_noflat
		if target.transformation == 0
			S_StartSound(target, P_RandomRange(sfx_whurt0,sfx_whurt7))
			S_StartSound(target, sfx_wltran)
			target.transformation = 2
		end
		return true
	end */
	S_StartSound(target, P_RandomRange(sfx_whurt0,sfx_whurt7))
	target.spawning = min(CV_FindVar("k_wl4hurtdrop").value,target.player.recordscore)
	P_AddPlayerScore(target.player, target.spawning*-1)
	repeat
		SpawnCoins(target, target.spawning)
	until target.spawning < 10
	P_AddPlayerScore(target.player, target.spawning) -- do this to not scam people out of their score if not a multiple of 10
		if CV_FindVar("k_wl4health").string == "On"
			if not (dmgType & DMG_DEATHMASK) and target.player.instad and inf and not (inf.type and inf.type == MT_EGGMAN_ICON)
				if inf.player
					P_AddPlayerScore(inf.player, 50)
				end
			end
			if target.player.powers[pw_shield]
			and shieldtake == true
				target.player.powers[pw_flashing] = 50
				P_DoPlayerPain(target.player, src, inf)
				S_StartSound(target, hitsound)
				P_RemoveShield(target.player)
			else
				target.player.powers[pw_flashing] = 50
				target.player.hp = $ - 1
				P_DoPlayerPain(target.player, src, inf)
				S_StartSound(target, hitsound)
				P_PlayerEmeraldBurst(target.player,false)
				P_PlayerWeaponAmmoBurst(target.player)
				P_PlayerFlagBurst(target.player,false)
				if target.player.hp == 0 and target.player.hpdivvies < 8
					P_KillMobj(target,inf,src)
				elseif target.player.hp == 1
					target.player.leveltimeadd = leveltime % 53
				end
			end
			return true
		end
	end
end, MT_PLAYER)

addHook("MobjDeath", function(target, inf, src, dmgType)
	/* if (dmgType & DMG_CRUSHED) and cv_kombiwl4trans.value == 1 and not mapheaderinfo[gamemap].kombi_wl4_noflat
		if target.transformation == 0
			S_StartSound(target, P_RandomRange(sfx_whurt0,sfx_whurt7))
			S_StartSound(target, sfx_wltran)
			target.transformation = 2
		end
		return true
	end */
	target.player.hp = 0
end, MT_PLAYER)

addHook("MobjThinker", function(mobj)
	A_CapeChase(mobj.target,1,0)
	if mobj.target.player
		local player = mobj.target.player
	end
	mobj.frame = player.hp
	print("Active!",mobj.x)
end, MT_WLHEALTHDISP)

addHook("MobjDeath", function(mo, inf, src)
		if not (mo.flags & MF_ENEMY) or not (src) or not (src.skin == "kombi") or not (src.player) then return end
		src.player.scoreadd = 0
		-- Don't check for console command in this function to not scam the player out of health if they decide to enable it again like the cowards they are
		//P_SpawnMobj(mo.x, mo.y, mo.z, MT_WLHEALTHTICK)
		if CV_FindVar("k_wl4health").string == "On" -- ...But we don't want to keep the auditory information despite this
			S_StartSound(mo, sfx_wmhart)
		end
		src.player.hpdivvies = $+1
		if src.player.hpdivvies > 7 -- do this to make places like the GHZ Armageddon Shield area give you the health it's supposed to
		and src.player.hp < cv_kombiwl4max.value
			src.player.hp = $ + 1
			src.player.hpdivvies = 0
		end
		if CV_FindVar("k_wl4scoring").string == "On"
			mo.spawning = coinlist[mo.type] or 50
			repeat
				SpawnCoins(mo, mo.spawning)
			until mo.spawning < 10
		end
	local type = mo.type
	if (src) and (src.player) and (src.skin == "kombi") and not ((type > MT_BUGGLE) and (type < MT_SPINBOBERT_FIRE2))
		and not ((type > MT_COIN) and (type <= MT_SHLEEP))
		and not (type == MT_FANG)
		local flickysfx = P_SpawnMobjFromMobj(mo,0,0,0,MT_THOK)
		flickysfx.tics,flickysfx.fuse = 60,60 flickysfx.flags2 = MF2_DONTDRAW flickysfx.spriteyscale = 1
		S_StartSound(flickysfx, sfx_saflik)
		S_StartSound(flickysfx, sfx_saexpl) -- should be available since X-Tra freeslots before we could potentially even do this
	
		if not mo.spawnedsaexplosion --Makes the mod stackable and modifyable. You can add it to a MobjSpawn hook for example.
		and not mo.player --...duh.
		
			mo.spawnedsaexplosion = true
			mo.flags2 = $|MF2_DONTDRAW
			mo.spritexscale,mo.spriteyscale = 1,1
		
			local expl = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_SAEXPL)
			expl.scale = max(mo.scale, mo.height/32) --A bigger explosion the bigger you are!
			expl.target = mo
		end
	end
end)

local function CoinThinker(mobj)
	if mobj.collectwait > 0
		mobj.collectwait = $ - 1
	end
	mobj.scale = 2*FRACUNIT
end

local function CoinSpawn(mobj)
	if not ((mobj.flags2 & MF2_TWOD) or twodlevel)
		mobj.angle = FixedAngle(P_RandomRange(0, 359)*FRACUNIT)
	end
	P_Thrust(mobj, mobj.angle, 6*FRACUNIT)
	P_SetObjectMomZ(mobj, 12*FRACUNIT)
	mobj.collectwait = 13
end

local function WariYahoo(mobj)
	S_StartSound(mobj, P_RandomRange(sfx_waow0,sfx_waow18))
end

addHook("TouchSpecial", function(mobj,toucher) --I swear there's a way to pass custom arguments to these that i just don't know about
	if not toucher.player.skin == "kombi" or mobj.collectwait then return true end
	P_AddPlayerScore(toucher.player, 10)
	S_StartSound(toucher, sfx_wlcoi1)
	mobj.state = S_NULL
end, MT_WARIOLAND10COIN)

addHook("TouchSpecial", function(mobj,toucher)
	if not toucher.player.skin == "kombi" or mobj.collectwait then return true end
	P_AddPlayerScore(toucher.player, 50)
	S_StartSound(toucher, sfx_wlcoi2)
	mobj.state = S_NULL
end, MT_WARIOLAND50COIN)

addHook("TouchSpecial", function(mobj,toucher)
	if not toucher.player.skin == "kombi" or mobj.collectwait then return true end
	P_AddPlayerScore(toucher.player, 100)
	S_StartSound(toucher, sfx_wlcoi3)
	mobj.state = S_NULL
end, MT_WARIOLAND100COIN)

addHook("TouchSpecial", function(mobj,toucher)
	if not toucher.player.skin == "kombi" or mobj.collectwait then return true end
	P_AddPlayerScore(toucher.player, 500)
	S_StartSound(toucher, sfx_wlcoi4)
	mobj.state = S_NULL
end, MT_WARIOLAND500COIN)

addHook("MobjSpawn", CoinSpawn, MT_WARIOLAND10COIN)
addHook("MobjSpawn", CoinSpawn, MT_WARIOLAND50COIN)
addHook("MobjSpawn", CoinSpawn, MT_WARIOLAND100COIN)
addHook("MobjSpawn", CoinSpawn, MT_WARIOLAND500COIN)
addHook("MobjThinker", CoinThinker, MT_WARIOLAND10COIN)
addHook("MobjThinker", CoinThinker, MT_WARIOLAND50COIN)
addHook("MobjThinker", CoinThinker, MT_WARIOLAND100COIN)
addHook("MobjThinker", CoinThinker, MT_WARIOLAND500COIN)

addHook("MobjThinker", function(mobj)
	//print(mobj.sprite,mobj.frame)
end, MT_SCORE)

addHook("MobjThinker", function(mobj)
	mobj.scale = 2*FRACUNIT
	if mobj.awake
		A_HomingChase(mobj,R_PointToDist2(mobj.x, mobj.y, mobj.target.x, mobj.target.y)/3,0)
	end
end, MT_KEYZER)

addHook("MobjThinker", function(mobj)
	if not mobj.target
		mobj.state = S_NULL
	else
		P_SetOrigin(mobj, mobj.target.x+(cos(mobj.target.player.drawangle)*-36), mobj.target.y+(sin(mobj.target.player.drawangle)*-36), mobj.target.z+FRACUNIT*40)
	end
end, MT_KEYZERFOLLOW)

addHook("MobjSpawn", function(mobj)
	mobj.awake = false
end, MT_KEYZER)

addHook("TouchSpecial", function(mobj,toucher)
	if not mobj.awake
		mobj.awake = true
		mobj.target = toucher.player.keyzerfollow or toucher
		mobj.state = S_KEYZERAWAKE
		token = $ + 1
		S_StartSound(mobj, sfx_keyzer)
		WariYahoo(toucher)
	end
	return true
end,MT_KEYZER)