local function SafeFreeSlot(...)
	for _,slot in ipairs({...})
		if not rawget(_G, slot) freeslot(slot) end -- Ensure we don't accidentally overlap existing freeslots
	end
end
SafeFreeSlot("sfx_sdrown","sfx_sfall","sfx_sgener","sfx_2drown","sfx_2fall","sfx_2gener")
sfxinfo[sfx_sdrown].caption = 'Drowning'
sfxinfo[sfx_sfall].caption = '\x85"No!!"\x80'
sfxinfo[sfx_sgener].caption = '\x85"No!"\x80'
sfxinfo[sfx_2drown].caption = 'Drowning'
sfxinfo[sfx_2fall].caption = '\x85"Huehh!"\x80'
sfxinfo[sfx_2gener].caption = '\x85"No!"\x80'

addHook("MobjDeath", function(mobj, inflictor, source, damageType)
	if mobj.skin == "kombi"
		if damageType == DMG_DEATHPIT
			if P_RandomChance(3*FRACUNIT/4)
				S_StartSound(mobj,sfx_sfall)
			else
				S_StartSound(mobj,sfx_2fall)
			end
		elseif damageType == DMG_DROWNED or damageType == DMG_SPACEDROWN
		if P_RandomChance(3*FRACUNIT/4)
				S_StartSound(mobj,sfx_sdrown)
			else
				S_StartSound(mobj,sfx_2drown)
			end
		else
			if P_RandomChance(3*FRACUNIT/4)
				S_StartSound(mobj,sfx_sgener)
			else
				S_StartSound(mobj,sfx_2gener)
			end
		end
		return true
	end
end, MT_PLAYER)